// Name: Nathaniel Paulus
// Date: April 18, 2018
// Lab number: 2
// Description: Solves a quadratic equation in the form ax^2 + bx + c = 0,
// where a, b, and c are the inputs.

#include <iostream>
#include <cmath>
#include <sstream>
using namespace std;

int main() {
  int a, b, c;
  cout << "For a quadratic equation in the form ax^2 + bx + c = 0, enter a: ";
  cin >> a;
  cout << "Enter b: ";
  cin >> b;
  cout << "Enter c: ";
  cin >> c;
  double descriminant = sqrt(b*b-4*a*c);
  double answerA = (-1*b+descriminant)/(2*a), answerB = (-1*b-descriminant)/(2*a);

  stringstream sstm;
  sstm << a << "x^2 + " << b << "x + " << c << " = 0";
  string equation = sstm.str();

  if (std::isnan(answerA) && std::isnan(answerB)) {
    cout << "There is no real solution to the equation " << equation << "." << endl;
  }
  else if (!std::isnan(answerA) && !std::isnan(answerB)) {
    cout << "The roots of the equation " << equation << " are " << answerA << " and " << answerB << "." << endl;
  }
  else {
    cout << "The solution to the equation " << equation << " is " << (std::isnan(answerA) ? answerB : answerA) << "." << endl;
  }
}
