// Name: Nathaniel Paulus
// Date: April 23, 2018
// Lab number: 4
// Description: Defines a class batsman with various related members

#include <iostream>
#include <iterator>

using namespace std;

// An extra char is needed for the null byte
const int bcodelength = 4+1;
const int bnamelength = 20+1;

class batsman {
  private:
    char bcode[bcodelength], bname[bnamelength];
    int innings, notout, runs;
    float batavg;
    float calcavg() {
      this->batavg = ((float) runs)/(innings-notout);
      return this->batavg;
    }
  public:
    float readdata(char bcode[bcodelength], char bname[bnamelength], int innings, int notout, int runs) {
      copy(bcode, bcode+bcodelength, this->bcode);
      copy(bname, bname+bnamelength, this->bname);
      this->innings = innings;
      this->notout = notout;
      this->runs = runs;
      return calcavg();
    }
    void displaydata() {
      cout << "Batter " << this->bname << " (bcode " << this->bcode << ") ";
      cout << "has a batting average of " << this->batavg << " (" << this->notout << " notouts and ";
      cout << this->runs << " runs over " << this->innings << " innings)." << endl;
    }
};

int main() {
  batsman b;
  char bcode[bcodelength], bname[bnamelength];
  int innings, notout, runs;
  string garbage;

  cout << "Batter's name: ";
  cin.get(bname, bnamelength);

  getline(cin, garbage);
  cout << "Batter code: ";
  cin.get(bcode, bcodelength);

  cout << "Innings: ";
  cin >> innings;
  cout << "Notouts: ";
  cin >> notout;
  cout << "Runs: ";
  cin >> runs;

  b.readdata(bcode, bname, innings, notout, runs);
  b.displaydata();
}